/*
	This is a part of the source code for Pro/DESKTOP.
	Copyright (C) 1998-1999 Parametric Technology Corporation.
	All rights reserved.
*/

//	CreateLineMiddleToMiddle.cpp

#include <stdafx.h>

#include "cUtility.h"
#include "cApplication.h"
#include "cLine.h"

//	Creates a line using the mid points of the two
//	given lines and returns the line created
//	After creation the line is AutoConstrained.

HRESULT CreateLineMiddleToMiddle(ILine *line1, ILine *line2, ILine **newLine1)
{

	START_METHOD("CreateLineMiddleToMiddle")

	HRESULT status = CONV_SUCCESS;
	
	// Get the mid point of the first line
	IPoint *midPoint1 = NULL;
	status = GetMidPoint(line1, &midPoint1);
	CHECK_RETURN_STATUS(status)

	// Get the mid point of the second line
	IPoint *midPoint2 = NULL;
	status = GetMidPoint(line2, &midPoint2);
	CHECK_RETURN_STATUS(status)

	ILine *pLine1 = NULL;
	status = CreateLinePointToPoint(midPoint1, midPoint2, &pLine1);
	CHECK_RETURN_STATUS(status)

	*newLine1 = pLine1;

	END_METHOD("CreateLineMiddleToMiddle")
}
