/*
	This is a part of the source code for Pro/DESKTOP.
	Copyright (C) 1998-1999 Parametric Technology Corporation.
	All rights reserved.
*/

// COMClientView.h : interface of the CCOMClientView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMClientVIEW_H__8A2BD350_A6B8_11D1_842A_00AA00A86226__INCLUDED_)
#define AFX_COMClientVIEW_H__8A2BD350_A6B8_11D1_842A_00AA00A86226__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "funcheader.h"

class CCOMClientView : public CView
{
protected: // create from serialization only
	CCOMClientView();
	DECLARE_DYNCREATE(CCOMClientView)

// Attributes
public:
	CCOMClientDoc* GetDocument();
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCOMClientView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCOMClientView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CCOMClientView)
	afx_msg void OnAdim();
	afx_msg void OnClosedw();
	afx_msg void OnCone();
	afx_msg void OnCyl();
	afx_msg void OnDatum();
	afx_msg void OnDdim();
	afx_msg void OnGeomtol();
	afx_msg void OnLdim();
	afx_msg void OnNote();
	afx_msg void OnRdim();
	afx_msg void OnRect();
	afx_msg void OnRun();
	afx_msg void OnTorous();
	afx_msg void OnPartclose();
	afx_msg void OnPartopen();
	afx_msg void OnPartsave();
	afx_msg void OnSpindle();
	afx_msg void OnWheel();
	afx_msg void OnAddcomponent();
	afx_msg void OnSpwhassembly();
	afx_msg void OnDrawingclose();
	afx_msg void OnDrawingopen();
	afx_msg void OnDrawingsave();
	afx_msg void OnDrawingsaveas();
	afx_msg void OnPartsaveas();
	afx_msg void OnNewdrawing();
	afx_msg void OnNewpart();
	afx_msg void OnSetdrawingname();
	afx_msg void OnSetdrawingtitle();
	afx_msg void OnSetpartname();
	afx_msg void OnSetparttitle();
	afx_msg void OnAlignplanes();
	afx_msg void OnCenteraxes();
	afx_msg void OnMassproperties();
	afx_msg void OnMateplanes();
	afx_msg void OnOrientaxes();
	afx_msg void OnNewSketch();
	afx_msg void OnCreateExtrusion();
	afx_msg void OnCreateHole();
	afx_msg void OnCreateProjection();
	afx_msg void OnCreateRevolution();
	afx_msg void OnCreateSimpleBlend();
	afx_msg void OnCreateSweep();
	afx_msg void OnCreateVariableBlend();
	afx_msg void OnHideOtherSketches();
	afx_msg void OnMidPlane();
	afx_msg void OnOffsetPlane();
	afx_msg void OnOrientedPlane();
	afx_msg void OnPlaneOfObject();
	afx_msg void OnPlaneThroughObjects();
	afx_msg void OnRepositionAxes();
	afx_msg void OnReverseAxes();
	afx_msg void OnRotateAxes();
	afx_msg void OnTranslateAxes();
	afx_msg void OnUncondemnAll();
	afx_msg void OnUpdateDesign();
	afx_msg void OnHollow();
	afx_msg void OnUsecomponent();
	afx_msg void OnCreateLine();
	afx_msg void OnCreateCircle();
	afx_msg void OnCreateRectangle();
	afx_msg void OnCreateArcStartEndCenter();
	afx_msg void OnDeleteLines();
	afx_msg void OnOffsetChain();
	afx_msg void OnTranslateObjects();
	afx_msg void OnRotateObjects();
	afx_msg void OnScaleObjects();
	afx_msg void OnRectangularDuplicate();
	afx_msg void OnCircularDuplicate();
	afx_msg void OnMirrorInX();
	afx_msg void OnMirrorInY();
	afx_msg void OnMirrorInBoth();
	afx_msg void OnMakeParallel();
	afx_msg void OnMakePerpendicular();
	afx_msg void OnMakeColinear();
	afx_msg void OnMakeTangentLineCircle();
	afx_msg void OnMakeTangentCircleCircle();
	afx_msg void OnMakeConcentric();
	afx_msg void OnMakeEqualLength();
	afx_msg void OnMakeEqualRadius();
	afx_msg void OnFixLine();
	afx_msg void OnConstrainSize();
	afx_msg void OnConstrainSeparationPointToPoint();
	afx_msg void OnConstrainSeparationPointToLine();
	afx_msg void OnConstrainSeparationLineToLine();
	afx_msg void OnMakeRadialDim();
	afx_msg void OnMakeAngularDim();
	afx_msg void OnCreateLineStartToStart();
	afx_msg void OnCreateLineStartToMiddle();
	afx_msg void OnCreateLineStartToEnd();
	afx_msg void OnCreateLineMiddleToStart();
	afx_msg void OnCreateLineMiddleToMiddle();
	afx_msg void OnCreateLineMiddleToEnd();
	afx_msg void OnCreateLineEndToStart();
	afx_msg void OnCreateLineEndToMiddle();
	afx_msg void OnCreateLineEndToEnd();
	afx_msg void OnCreateLineCenterToStart();
	afx_msg void OnCreateLineCenterToMiddle();
	afx_msg void OnCreateLineCenterToEnd();
	afx_msg void OnCreateLineStartToCenter();
	afx_msg void OnCreateLineMiddleToCenter();
	afx_msg void OnCreateLineEndToCenter();
	afx_msg void OnCreateLineCenterToCenter();
	afx_msg void OnGearDesign();
	afx_msg void OnRemoveConstraints();
	afx_msg void OnUpdateRun(CCmdUI* pCmdUI);
	afx_msg void OnUpdateClosedw(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in COMClientView.cpp
inline CCOMClientDoc* CCOMClientView::GetDocument()
   { return (CCOMClientDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COMClientVIEW_H__8A2BD350_A6B8_11D1_842A_00AA00A86226__INCLUDED_)
